%global gem_name bootsnap
Name:                rubygem-%{gem_name}
Version:             1.15.0
Release:             1
Summary:             Boot large ruby/rails apps faster
License:             MIT
URL:                 https://github.com/Shopify/bootsnap
Source0:             https://rubygems.org/gems/%{gem_name}-%{version}.gem
# git clone http://github.com/Shopify/bootsnap.git --no-checkout
# cd bootsnap && git archive -v -o bootsnap-1.15.0-tests.txz v1.15.0 test/
Source1:             %{gem_name}-%{version}-tests.txz
# https://github.com/Shopify/bootsnap/issues/431
# https://github.com/Shopify/bootsnap/commit/72202aab5e5b3602ece4e8748bcdeefe2d789ab5
Patch0:              Use-RbConfig-CONFIG-rubylibdir-to-check-for-stdlib-files.patch
Patch1:              Use-RbConfig-CONFIG-rubylibdir-to-check-for-stdlib-files-test.patch
BuildRequires:       ruby(release) rubygems-devel ruby-devel >= 2.0.0 rubygem(minitest)
BuildRequires:       rubygem(mocha) rubygem(msgpack) gcc
BuildRequires:       rubygem(bundler)
ExcludeArch:         armv7hl
%description
Bootsnap is a library that plugs into Ruby, with optional support
for ActiveSupport and YAML, to optimize and cache expensive computations.

%package doc
Summary:             Documentation for %{name}
Requires:            %{name} = %{version}-%{release}
BuildArch:           noarch
%description doc
Documentation for %{name}.

%prep
%setup -q -n %{gem_name}-%{version} -b 1
%patch0 -p1
pushd %{_builddir}
%patch1 -p1
popd
sed -i -e "/^\s*\$CFLAGS / s/^/#/g" \
  ext/bootsnap/extconf.rb

%build
gem build ../%{gem_name}-%{version}.gemspec
%gem_install

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
        %{buildroot}%{gem_dir}/
mkdir -p %{buildroot}%{gem_extdir_mri}/%{gem_name}
cp -a .%{gem_extdir_mri}/gem.build_complete %{buildroot}%{gem_extdir_mri}/
cp -a .%{gem_extdir_mri}/%{gem_name}/*.so %{buildroot}%{gem_extdir_mri}/%{gem_name}
rm -rf %{buildroot}%{gem_instdir}/ext/

mkdir -p %{buildroot}%{_bindir}
cp -a .%{_bindir}/* \
        %{buildroot}%{_bindir}/

find %{buildroot}%{gem_instdir}/exe -type f | xargs chmod a+x

%check
pushd .%{gem_instdir}
ln -s %{_builddir}/test test
cat <<GEMFILE > Gemfile
gem "minitest"
gem "mocha"
gem "msgpack"
GEMFILE

RUBYOPT="-I$(dirs +1)%{gem_extdir_mri}:$(dirs +1)%{gem_libdir}" \
  ruby -Itest -e 'Dir.glob "./test/**/*_test.rb", &method(:require)'
popd

%files
%dir %{gem_instdir}
%{_bindir}/bootsnap
%{gem_extdir_mri}
%license %{gem_instdir}/LICENSE.txt
%{gem_instdir}/exe
%{gem_libdir}
%exclude %{gem_cache}
%{gem_spec}

%files doc
%doc %{gem_docdir}
%doc %{gem_instdir}/CHANGELOG.md
%doc %{gem_instdir}/README.md

%changelog
* Tue Aug 01 2023 yaoxin <yao_xin001@hoperun.com> - 1.15.0-1
- Update to 1.15.0

* Tue Jul 05 2022 xu_ping <xuping33@h-partners.com> - 1.3.2-4
- fixed mocha/minitest dependency issue due to rubygem-mocha upgrade

* Thu Jan 27 2022 wulei <wulei@huawei.com> - 1.3.2-3
- fix no implicit conversion of String into Integer

* Tue Sep 8 2020 yanan li <liyanan032@huawei.com> - 1.3.2-2
- fix build fail

* Tue Aug 18 2020 wanglin <wanglin175@huawei.com> - 1.3.2-1
- package init
